// ========================== ここから ==============================
//ファイル名    button_push_detect.c
//作成日     2024.4.6
//更新日     2024.4.6
//作成者     Shimaneko
//バージョン    1.0
//コンパイラ    MPLAB XC8 V2.4.0
//ＰＩＣ        PIC18F14K50
//クロック      12MHz EXT PLLx4 48MHz
//
//概要
//     ボタン処理
//
// ====================== ここまで ===================================
#include<xc.h>
#include "global_define.h"
#include "button_push_detect.h"


void button_push_detect(void)
{
    static unsigned short counter1 = 0;
    static unsigned short counter2 = 0;
    static unsigned short counter3 = 0;
    
    detect_func(PORT_START_END_BUTTON, &counter1, &start_end_button_long_glb, &start_end_button_short_glb);
    detect_func(PORT_MIC_ONOFF_BUTTON, &counter2, &mic_onoff_button_long_glb, &mic_onoff_button_short_glb);
    detect_func(PORT_VIDEO_ONOFF_BUTTON, &counter3, &video_onoff_button_long_glb, &video_onoff_button_short_glb);
	
}
// 検出関数本体
//　unsigned char button_port //チェックする端子
// unsigned char *counter,  //ボタンを押している時間をカウント
// unsigned char *detect_long_push, //長押しを検出したら立つフラグ
// unsigned char *detect_short_push　//短押しを検出したら立つフラグ
//
void detect_func(unsigned char button_port, unsigned short *counter, unsigned char *detect_long_push, unsigned char *detect_short_push)
{
    
    //ボタンを押している間カウントアップ
   if(button_port == BUTTON_ON)
   {
         if(*counter < BUTTON_COUNTER_MAX_NUM)
            *counter = *counter + 1;
         else
            *counter = BUTTON_COUNTER_MAX_NUM;  
         
         *detect_long_push = INT_OFF;
         *detect_short_push = INT_OFF;
         
    }
    //ボタンを離したら判定処理
    else
    {
        //長押し判定
        if(*counter > BUTTON_DETECT_LONG_THRESHOLD)
        {
            *detect_long_push = INT_ON;
            *detect_short_push = INT_OFF;
        }
        //短押し判定
        else if(*counter > BUTTON_DETECT_SHORT_THRESHOLD)
        {
            *detect_long_push = INT_OFF;
            *detect_short_push = INT_ON;
        }
        //閾値以下
        else
        {
            *detect_long_push = INT_OFF;
            *detect_short_push = INT_OFF;
        }
        
        *counter = 0;
            
    
    }
    
}