#ifndef _GLOBAL_DEFINE_
#define _GLOBAL_DEFINE_

//#define _DEBUG_MODE_
//#define _BUTTON_TEST_ //ボタンを押したときに送信するもともとのインプリ

#define _XTAL_FREQ 48000000   //PICのクロックをHzで設定(シミュレータ用)
#define PIC_CLOCK 48000000


//端子割り当て
#define PORT_KANA_LED PORTCbits.RC5
#define PORT_NUMLOCK_LED PORTCbits.RC4
#define PORT_CAPSLOCK_LED PORTCbits.RC3
#define PORT_SCROLL_LED PORTCbits.RC6
#define PORT_DEBUG_LED PORTCbits.RC7
#define PORT_START_END_BUTTON PORTBbits.RB7
#define PORT_ZOOM_TEAMS_BUTTON PORTBbits.RB6
#define PORT_MIC_ONOFF_BUTTON PORTBbits.RB5
#define PORT_VIDEO_ONOFF_BUTTON PORTBbits.RB4

// USB HIDコード割り当て
#define LETR_A 0x04
#define LETR_B 0x05
#define LETR_C 0x06
#define LETR_D 0x07
#define LETR_E 0x08
#define LETR_F 0x09
#define LETR_G 0x0A
#define LETR_H 0x0B
#define LETR_I 0x0C
#define LETR_J 0x0D
#define LETR_K 0x0E
#define LETR_L 0x0F
#define LETR_M 0x10
#define LETR_N 0x11
#define LETR_O 0x12
#define LETR_P 0x13
#define LETR_Q 0x14
#define LETR_R 0x15
#define LETR_S 0x16
#define LETR_T 0x17
#define LETR_U 0x18
#define LETR_V 0x19
#define LETR_W 0x1A
#define LETR_X 0x1B
#define LETR_Y 0x1C
#define LETR_Z 0x1D


//割り込み
#define INT_ON 1
#define INT_OFF 0

//LED点灯
#define LED_ON 1
#define LED_OFF 0

//ボタンONOFF
#define BUTTON_ON 0
#define BUTTON_OFF 1

//ボタンを押されたかどうかの判定閾値
#define BUTTON_DETECT_LONG_THRESHOLD 250 //4mS * 500 = 1s
#define BUTTON_DETECT_SHORT_THRESHOLD 5 //4mS * 100 = 20mS
#define BUTTON_COUNTER_MAX_NUM 65535

//Teams or ZOOMの選択
#define SELECT_TEAMS 1
#define SELECT_ZOOM 0

extern unsigned char timer2_interrupt_glb;
extern unsigned char start_end_button_short_glb;
extern unsigned char start_end_button_long_glb;
extern unsigned char mic_onoff_button_short_glb;
extern unsigned char mic_onoff_button_long_glb;
extern unsigned char video_onoff_button_short_glb;
extern unsigned char video_onoff_button_long_glb;

void global_define();

#endif
